"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwaitingValidationEventHandler = exports.AwaitingValidationEvent = void 0;
const cqrs_1 = require("@nestjs/cqrs");
const common_1 = require("@nestjs/common");
const configuration_1 = require("./configuration");
const validate_service_1 = require("../validate.service");
const queueThrottle_1 = require("./queueThrottle");
class AwaitingValidationEvent {
}
exports.AwaitingValidationEvent = AwaitingValidationEvent;
let AwaitingValidationEventHandler = class AwaitingValidationEventHandler {
    constructor(batchConfiguration, validateService) {
        this.batchConfiguration = batchConfiguration;
        this.validateService = validateService;
        const { trigger, unsubscribe } = queueThrottle_1.queueThrottle(() => this.validateService.validateTask(), this.batchConfiguration.validateAggregateSeconds);
        this.handle = trigger;
        this.unsubscribe = unsubscribe;
    }
    onApplicationBootstrap() {
        this.handle();
    }
    onModuleDestroy() {
        this.unsubscribe();
    }
};
AwaitingValidationEventHandler = __decorate([
    cqrs_1.EventsHandler(AwaitingValidationEvent),
    __param(0, common_1.Inject(configuration_1.BATCH_CONFIGURATION_TOKEN)),
    __metadata("design:paramtypes", [Object, validate_service_1.ValidateService])
], AwaitingValidationEventHandler);
exports.AwaitingValidationEventHandler = AwaitingValidationEventHandler;
//# sourceMappingURL=validate.batch.js.map