import { Repository, Connection } from 'typeorm';
import { EnergyTransferRequest, NewAttributesParams, State } from '../EnergyTransferRequest';
import { EnergyTransferRequestEntity } from './EnergyTransferRequest.entity';
import { EnergyTransferRequestRepository } from './EnergyTransferRequest.repository';
export declare class EnergyTransferRequestPostgresRepository implements EnergyTransferRequestRepository {
    private repository;
    private connection;
    constructor(repository: Repository<EnergyTransferRequestEntity>, connection: Connection);
    save(entity: EnergyTransferRequest): Promise<void>;
    saveManyInTransaction(entities: EnergyTransferRequest[]): Promise<void>;
    createNew(command: NewAttributesParams): Promise<EnergyTransferRequest>;
    findAll(): Promise<EnergyTransferRequest[]>;
    findByCertificateId(certificateId: number): Promise<EnergyTransferRequest | null>;
    findById(id: number): Promise<EnergyTransferRequest | null>;
    findByState(state: State): Promise<EnergyTransferRequest[]>;
    updateWithLock(id: number, cb: (entity: EnergyTransferRequest) => void): Promise<void>;
}
